<script lang="ts" setup>
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import { useLoadingStore } from '@/stores/loading';
import type { Product } from '@/types/Product';
import { useProductsStore } from '@/stores/product';
const productStore = useProductsStore()
const headers = [
  {
    title: 'Id',
    key: 'id'
  },
  {
    title: 'Name',
    key: 'name'
  },
  {
    title: 'Price',
    key: 'price'
  }, 
  {
    title: 'Type',
    key: 'type'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const loadingStore = useLoadingStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const initilProduct: Product = {
  id: -1,
  name: '',
  price: 0,
  type: 0
}
const editedProduct = ref<Product>(JSON.parse(JSON.stringify(initilProduct)))
const products = ref<Product[]>([])
let editedIndex = -1
let lastId = 4
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedProduct.value = Object.assign({}, initilProduct)
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  closeDelete()
  await productStore.deleteUser(editedProduct.value)
}
function editItem(item: Product) {
  editedProduct.value = Object.assign({}, item)
  dialog.value = true
}
function deleteItem(item: Product) {
  editedProduct.value = Object.assign({}, item)
  dialogDelete.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedProduct.value = Object.assign({}, initilProduct)
    editedIndex = -1
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return

  closeDialog()
  await productStore.saveProduct(editedProduct.value)
}
 

onMounted(() => {
  productStore.getProducts()
})
</script>
<template>
  <!-- <div>
    <v-table>
      <thead>
        <tr>
          <th class="text-left">ID</th>
          <th class="text-left">Email</th>
          <th class="text-left">Full Name</th>
          <th class="text-left">Gender</th>
          <th class="text-left">Roles</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="item in users" :key="item.id">
          <td>{{ item.id }}</td>
          <td>{{ item.email }}</td>
          <td>{{ item.fullName }}</td>
          <td>{{ item.gender }}</td>
          <td>{{ item.roles.join(',') }}</td>
        </tr>
      </tbody>
    </v-table>
  </div> -->
  <div>
    <v-data-table :headers="headers" :items="productStore.products">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Products</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog -->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" v-bind="props"> New Product </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">New Product</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedProduct.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Product Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedProduct.price"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Price"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedProduct.type"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Type"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="productStore.getProducts"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>
